// Copyright (c) 2016, 2018, 2021, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

import (
	"github.com/oracle/oci-go-sdk/v40/common"
)

// HostCisBenchmarkSettings CIS (Center for Internet Security) Benchmark scan settings for a host scan
type HostCisBenchmarkSettings struct {

	// The level of strictness to apply for CIS Benchmarks. Use 'NONE' to disable CIS Benchmark checks entirely.
	ScanLevel HostCisBenchmarkScanLevelEnum `mandatory:"false" json:"scanLevel,omitempty"`
}

func (m HostCisBenchmarkSettings) String() string {
	return common.PointerString(m)
}
